; ***************************************************************************
;	       *    AutoLisp Animation Program	 *
;	       *				 *
;	       *       Developed June 1987	 *
;	       *	      By:		 *
;	       *       Greg MacGeorge		 *
;	       *       2136 Glenworth Ave.	 *
;	       *       Louisville, Ky. 40218	 *
;	       *       (502) 458-0690		 *
; ***************************************************************************
;
;
;
;		 CONVERT RADIANS TO DEGREES
;
(DEFUN RTD (A)
     (* 180 (/ A PI))
)
;
;
(DEFUN AN ()
     (SETQ A (GETSTRING "WHAT'S THE NAME OF THE FILE ? "))
     (SETQ FILE (STRCAT A ".SCR"))
     (SETQ N (GETINT "HOW MANY COMMANDS TO PERFORM ? "))
)
;
;
(DEFUN AN1 ()
     (PRINC "(SETVAR " F)
     (WRITE-CHAR 34 F)
     (PRINC "HIGHLIGHT" F)
     (WRITE-CHAR 34 F)
     (PRINC " 0)" F)
     (WRITE-LINE "" F)
     (PRINC "(SETVAR " F)
     (WRITE-CHAR 34 F)
     (PRINC "BLIPMODE" F)
     (WRITE-CHAR 34 F)
     (PRINC " 0)" F)
     (WRITE-LINE "" F)
)
;
;
(DEFUN AN2 ()
     (SETQ B "RUN")
     (SETQ W (STRCAT B ".SCR"))
     (SETQ Z (OPEN W "w"))
     (COMMAND "MENU"
	(WRITE-LINE "MOTION")
     )
     (SETQ C (GETSTRING "ENTER COMMAND TO BE PERFORMED "))
     (WRITE-LINE C F)
     (IF (= C "MOVE") (AN3) "NO PROGRAM")
     (IF (= C "ERASE") (AN4) "NO PROGRAM")
     (IF (= C "ROTATE") (AN5) "NO PROGRAM")
     (IF (= C "INSERT") (AN6) "NO PROGRAM")
     (IF (= C "COPY") (AN7) "NO PROGRAM")
)
;
;				 MOVE SUB-ROUTINE
(DEFUN AN3 ()
     (PRINT)
     (SETQ O (GETINT "HOW MANY OBJECTS ? (5 MAX) "))
     (REPEAT O
	(PRINT)
	(SETQ LIST (ENTSEL "SELECT OBJECTS: "))
	(SETQ LIST (CDR LIST))
	(SETQ X1 (CAR (CAR LIST)))
	(SETQ Y1 (CADAR LIST))
	(SETQ X1 (RTOS X1 2 4))
	(SETQ Y1 (RTOS Y1 2 4))
	(SETQ LIST (STRCAT X1 "," Y1))
	(WRITE-LINE LIST F)
	(WRITE-LINE LIST Z)
     )
     (WRITE-LINE "" F)
     (WRITE-LINE "" Z)
; BASE POINT SELECTION
     (PRINT)
     (SETQ BASE (GETPOINT "SELECT BASE POINT: "))
     (SETQ X2 (CAR BASE))
     (SETQ Y2 (CADR BASE))
     (SETQ X2 (RTOS X2 2 4))
     (SETQ Y2 (RTOS Y2 2 4))
     (SETQ BASE1 (STRCAT X2 "," Y2))
     (WRITE-LINE BASE1 F)
     (WRITE-LINE BASE1 Z)
     (PRINT)
; SECOND POINT SELECTION
     (SETQ SEC (GETPOINT BASE "SELECT SECOND POINT: "))
     (SETQ X3 (CAR SEC))
     (SETQ Y3 (CADR SEC))
     (SETQ X3 (RTOS X3 2 4))
     (SETQ Y3 (RTOS Y3 2 4))
     (SETQ SEC (STRCAT X3 "," Y3))
     (WRITE-LINE SEC F)
     (WRITE-LINE SEC Z)
     (PRINT)
; PERFORM COMMAND
     (CLOSE Z)
     (SETQ R (OPEN W "r"))
     (COMMAND "MOVE"
	(READ-LINE R)
	(READ-LINE R)
	(READ-LINE R)
	(READ-LINE R)
	(READ-LINE R)
	(READ-LINE R)
	(READ-LINE R)
	(READ-LINE R)
     )
     (CLOSE R)
)
;
;
;				ERASE SUB-ROUTINE
(DEFUN AN4 ()
     (PRINT)
     (SETQ O (GETINT "HOW MANY OBJECTS ? (5 MAX) "))
     (REPEAT O
	(PRINT)
	(SETQ LIST (ENTSEL "SELECT OBJECTS: "))
	(SETQ LIST (CDR LIST))
	(SETQ X1 (CAR (CAR LIST)))
	(SETQ Y1 (CADAR LIST))
	(SETQ X1 (RTOS X1 2 4))
	(SETQ Y1 (RTOS Y1 2 4))
	(SETQ LIST (STRCAT X1 "," Y1))
	(WRITE-LINE LIST F)
	(WRITE-LINE LIST Z)
     )
     (WRITE-LINE "" F)
     (WRITE-LINE "" Z)
; PERFORM COMMAND
     (CLOSE Z)
     (SETQ R (OPEN W "r"))
     (COMMAND "ERASE"
	(READ-LINE R)
	(READ-LINE R)
	(READ-LINE R)
	(READ-LINE R)
	(READ-LINE R)
	(READ-LINE R)
	(READ-LINE R)
     )
     (CLOSE R)
)
;
;
;			    ROTATE SUB-ROUTINE
(DEFUN AN5 ()
     (PRINT)
     (SETQ O (GETINT "HOW MANY OBJECTS ? (5 MAX) "))
     (REPEAT O
	(PRINT)
	(SETQ LIST (ENTSEL "SELECT OBJECTS: "))
	(SETQ LIST (CDR LIST))
	(SETQ X1 (CAR (CAR LIST)))
	(SETQ Y1 (CADAR LIST))
	(SETQ X1 (RTOS X1 2 4))
	(SETQ Y1 (RTOS Y1 2 4))
	(SETQ LIST (STRCAT X1 "," Y1))
	(WRITE-LINE LIST F)
	(WRITE-LINE LIST Z)
     )
     (WRITE-LINE "" F)
     (WRITE-LINE "" Z)
; BASE POINT SELECTION
     (PRINT)
     (SETQ BASE (GETPOINT "SELECT BASE POINT: "))
     (SETQ X2 (CAR BASE))
     (SETQ Y2 (CADR BASE))
     (SETQ X2 (RTOS X2 2 4))
     (SETQ Y2 (RTOS Y2 2 4))
     (SETQ BASE1 (STRCAT X2 "," Y2))
     (WRITE-LINE BASE1 F)
     (WRITE-LINE BASE1 Z)
     (PRINT)
; ROTATION ANGLE SELECTION
     (SETQ RAD (GETANGLE BASE "ENTER ROTATION ANGLE: "))
     (SETQ ANG (RTD RAD))
     (SETQ ANG (RTOS ANG 2 4))
     (WRITE-LINE ANG F)
     (WRITE-LINE ANG Z)
     (PRINT)
; PERFORM COMMAND
     (CLOSE Z)
     (SETQ R (OPEN W "r"))
     (COMMAND "ROTATE"
	(READ-LINE R)
	(READ-LINE R)
	(READ-LINE R)
	(READ-LINE R)
	(READ-LINE R)
	(READ-LINE R)
	(READ-LINE R)
	(READ-LINE R)
     )
     (CLOSE R)
)
;
;			    INSERT SUB-ROUTINE
(DEFUN AN6 ()
     (PRINT)
     (SETQ LIST (GETSTRING "BLOCK NAME: "))
     (WRITE-LINE LIST F)
     (WRITE-LINE LIST Z)
     (PRINT)
     (GRAPHSCR)
; INSERTION POINT SELECTION
     (SETQ BASE (GETPOINT "SELECT INSERTION POINT: "))
     (SETQ X2 (CAR BASE))
     (SETQ Y2 (CADR BASE))
     (SETQ X2 (RTOS X2 2 4))
     (SETQ Y2 (RTOS Y2 2 4))
     (SETQ BASE1 (STRCAT X2 "," Y2))
     (WRITE-LINE BASE1 F)
     (WRITE-LINE BASE1 Z)
     (PRINT)
; X SCALE FACTOR
     (SETQ XSCALE (GETREAL "ENTER X SCALE FACTOR: "))
     (SETQ XSCALE (RTOS XSCALE 2 4))
     (WRITE-LINE XSCALE F)
     (WRITE-LINE XSCALE Z)
     (PRINT)
; Y SCALE FACTOR
     (SETQ YSCALE (GETREAL "ENTER Y SCALE FACTOR: "))
     (SETQ YSCALE (RTOS YSCALE 2 4))
     (WRITE-LINE YSCALE F)
     (WRITE-LINE YSCALE Z)
     (PRINT)
; ROTATION ANGLE
     (SETQ RAD (GETANGLE BASE "ENTER ROTATION ANGLE: "))
     (SETQ ANG (RTD RAD))
     (SETQ ANG (RTOS ANG 2 4))
     (WRITE-LINE ANG F)
     (WRITE-LINE ANG Z)
     (PRINT)
; PERFORM COMMAND
     (CLOSE Z)
     (SETQ R (OPEN W "r"))
     (COMMAND "INSERT"
	(READ-LINE R)
	(READ-LINE R)
	(READ-LINE R)
	(READ-LINE R)
	(READ-LINE R)
	(READ-LINE R)
     )
     (CLOSE R)
)
;
;				  COPY SUB-ROUTINE
;
(DEFUN AN7 ()
     (PRINT)
     (SETQ O (GETINT "HOW MANY OBJECTS ? (5 MAX) "))
     (REPEAT O
	(PRINT)
	(SETQ LIST (ENTSEL "SELECT OBJECTS: "))
	(SETQ LIST (CDR LIST))
	(SETQ X1 (CAR (CAR LIST)))
	(SETQ Y1 (CADAR LIST))
	(SETQ X1 (RTOS X1 2 4))
	(SETQ Y1 (RTOS Y1 2 4))
	(SETQ LIST (STRCAT X1 "," Y1))
	(WRITE-LINE LIST F)
	(WRITE-LINE LIST Z)
     )
     (WRITE-LINE "" F)
     (WRITE-LINE "" Z)
; BASE POINT SELECTION
     (PRINT)
     (SETQ BASE (GETPOINT "SELECT BASE POINT: "))
     (SETQ X2 (CAR BASE))
     (SETQ Y2 (CADR BASE))
     (SETQ X2 (RTOS X2 2 4))
     (SETQ Y2 (RTOS Y2 2 4))
     (SETQ BASE1 (STRCAT X2 "," Y2))
     (WRITE-LINE BASE1 F)
     (WRITE-LINE BASE1 Z)
     (PRINT)
; SECOND POINT SELECTION
     (SETQ SEC (GETPOINT BASE "SELECT SECOND POINT: "))
     (SETQ X3 (CAR SEC))
     (SETQ Y3 (CADR SEC))
     (SETQ X3 (RTOS X3 2 4))
     (SETQ Y3 (RTOS Y3 2 4))
     (SETQ SEC (STRCAT X3 "," Y3))
     (WRITE-LINE SEC F)
     (WRITE-LINE SEC Z)
     (PRINT)
; PERFORM COMMAND
     (CLOSE Z)
     (SETQ R (OPEN W "r"))
     (COMMAND "COPY"
	(READ-LINE R)
	(READ-LINE R)
	(READ-LINE R)
	(READ-LINE R)
	(READ-LINE R)
	(READ-LINE R)
	(READ-LINE R)
	(READ-LINE R)
     )
     (CLOSE R)
)
;
;			     ENDING STATEMENT
;
(DEFUN AN8 ()
     (SETQ LAST (OPEN "END.SCR" "w"))
     (WRITE-LINE "QUIT" LAST)
     (WRITE-LINE "Y" LAST)
     (WRITE-LINE "2" LAST)
     (WRITE-LINE "" LAST)
     (WRITE-LINE "SCRIPT" LAST)
     (WRITE-LINE A LAST)
     (CLOSE LAST)
     (COMMAND "SCRIPT"
	(WRITE-LINE "END")
     )
)
;
;
(DEFUN C:ANIMATE ()
     (SETQ APER (GETVAR "APERTURE"))
     (SETQ PICK (GETVAR "PICKBOX"))
     (SETVAR "APERTURE" 6)
     (SETVAR "PICKBOX" 6)
     (AN)
     (SETQ F (OPEN FILE "w"))
     (AN1)
     (REPEAT N
	(AN2)
     )
     (WRITE-LINE "DELAY" F)
     (WRITE-LINE "2000" F)
     (SETQ N (+ N 4))
     (REPEAT N
	(WRITE-LINE "U" F)
     )
     (WRITE-LINE "RSCRIPT" F)
     (CLOSE F)
     (COMMAND "MENU" ACAD)
     (SETVAR "APERTURE" APER)
     (SETVAR "PICKBOX" PICK)
     (AN8)
)
