(defun c:weld ()
        (setq ds (getvar "dimscale"))
        (setq wlinex (* ds 1.2))
        (setq dist1 (rtos (* ds 0.24) 2 2))
        (setq dist2 (rtos (* ds 0.15) 2 2))
        (setq fir (getpoint "\nPick start point of arrrow.."))
        (setq sec (getpoint "\nPick end of arrow line <start of weld line>.."))
        (setq secx (car sec))
        (setq secy (cadr sec))
        (command "layer" "s" "dim" /r
                    "dim" "leader" fir sec "" " " "exit"
                    "erase" "l" "")
        (setq side (getpoint "\nWhich side of last point is weld line? "))
        (setq sidex (car side))
        (setq field (getstring "\nField weld? <Y or N> "))
        (if (< sidex secx)
                (progn
                        (setq upl (strcat "@" dist1 "<135"))
                        (setq dl (strcat "@" dist1 "<225"))
                        (setq thir (list (- secx wlinex) secy))
                        (setq mid (list (- secx (/ wlinex 2.0)) secy))
                        (command "line" sec thir upl ""
                                    "line" thir dl "")
                        (if (or (= field "Y") (= field "y"))
                                (progn
                                        (setq fwdr (rtos (/ wlinex 2.0) 2 2))
                                        (setq up (strcat "@" fwdr "<90"))       
                                        (setq dr (strcat "@" dist2 "<315"))
                                        (setq dl (strcat "@" dist2 "<225"))
                                        (command "line" sec up dl dr "")
                                )
                        )
                )
                (progn
                        (setq upr (strcat "@" dist1 "<45"))
                        (setq dr (strcat "@" dist1 "<315"))
                        (setq thir (list (+ secx wlinex) secy))
                        (setq mid (list (+ secx (/ wlinex 2.0)) secy))
                        (command "line" sec thir upr ""
                                    "line" thir dr "")
                        (if (or (= field "Y") (= field "y"))
                                (progn
                                        (setq fwdr (rtos (/ wlinex 2.0) 2 2))
                                        (setq up (strcat "@" fwdr "<90"))
                                        (setq dl (strcat "@" dist2 "<225"))
                                        (setq dr (strcat "@" dist2 "<315"))
                                        (command "line" sec up dr dl "")
                                )
                        )
                )
        )
        (setq allrnd (getstring "\nWeld all around? <Y or N> "))
        (if (or (= allrnd "Y") (= allrnd "y"))
                (command "circle" sec "d" dist2)
        )
        (setq wsv (rtos (* ds 0.1697) 2 2))
        (setq midx (car mid))
        (setq fill (getstring "\nIs it a fillet weld? <Y or N> "))
        (if (or (= fill "Y") (= fill "y"))
                (progn
                        (setq wsize (getstring "\nWhat size? "))
                        (setq wsizeht (* ds 0.125))
                        (setq wsizetxty (- secy (* ds 0.2)))
                        (setq wsizetxtx (- midx 0.1))
                        (setq down (strcat "@" wsv "<270"))
                        (setq upr (strcat "@" dist1 "<45"))
                        (command "text" "s" "standard"
                                "r" (list wsizetxtx wsizetxty) wsizeht "0" wsize
                                "line" mid down upr "")
                )
                (progn
                        (setq bev (getstring "\nIs it a bevel weld? <Y or N> "))
                        (if (or (= fill "Y") (= fill "y"))
                                (progn
                                        (setq down (strcat "@" wsv "<270"))
                                        (setq rightdwn (strcat "@" dist1 "<315"))
                                        (command "line" mid rightdwn ""
                                                    "line" mid down "")
                                )
                        )
                )
        )
)
